{*******************************************************}
{                                                       }
{       JNI Wrapper for Delphi Demo 2                   }
{       Demonstrates the use of the TJavaParams         }
{       class to pass parameters to a static            }
{       method.  The test method simply echoes          }
{       the parameters to the console.                  }
{                                                       }
{       Copyright (c) 1998 Jonathan Revusky             }
{                                                       }
{       Java and Delphi Freelance programming           }
{             jon@revusky.com                      }
{                                                       }
{*******************************************************}

program jtest2;

// Example that shows how to call 
// a static method using the JNIWrapper unit.

{$APPTYPE CONSOLE}

    uses
        Windows, 
        SysUtils,
        Classes,
        JNIWrapper;
    
    var
        JNITest : TJavaClass;
        Params : TJavaParams;
        JMethod : TJavaMethod;
    
    begin
        try
            Params := TJavaParams.Create;
            Params.addInt(12);
            Params.addLong(1000000000);
            Params.addString('A Brave New World');
            JNITest := TJavaClass.Create('HelloWorld');
            JMethod := TJavaMethod.Create(JNITest, 'test', static, AInt, params, Nil);
            JMethod.Call(Params, Nil);
            Params.Free;
            JMethod.Free;
            JNITest.Free;
        except
            on EJvmException do 
                ShowException(ExceptObject, ExceptAddr);
        end;
end.

